#ifndef __MAP2BIN_H__
#define __MAP2BIN_H__

void readBin(string filename);
void write_map_to_bin(string filename);

/********************************
* WIP : Writes data to custom binary format
*********************************/
void write_map_to_bin(string filename)
{
    cout << "\nWRITE MAP TO BIN - Beta\n";
    string fileOutName = filename + ".ZTM";  //Z-Treme map custom binary file format
    ofstream binFile(fileOutName.c_str(), ios::out | ios::binary);

    /***** Writes to .txt just for testing and ensuring it's right *****/
    fileOutName = filename + ".txt";
    ofstream oTestFile(fileOutName.c_str(), ios::out);


    if (!binFile.is_open()) {cout << "\nERROR WHILE WRITING BINARY FILE!\n"; return;}

    binFile.write((char*)&total_mesh, sizeof(unsigned short));
                                                                                oTestFile << total_mesh << "\n";

    for (int i=0; i<total_mesh; i++)
    {
        //unsigned int MeshSize = (sizeof(mesh_array[i])) + (sizeof(POLYGON)*mesh_array[i].data.nbPolygon) + (sizeof(POINT)*mesh_array[i].data.nbPoint) + (sizeof(ATTR)*mesh_array[i].data.nbPolygon);
        //unsigned int MeshSize = (sizeof(mesh_array[i])) + (sizeof(POLYGON)*mesh_array[i].data.nbPolygon) + (sizeof(POINT)*mesh_array[i].data.nbPoint) + (sizeof(ATTR)*mesh_array[i].data.nbPolygon);
        //binFile.write((char*)&MeshSize, sizeof(unsigned int));
//                                                                                oTestFile << MeshSize << "\n";
        binFile.write((char*)&mesh_array[i].data.nbPoint, sizeof(unsigned int));
                                                                                oTestFile << mesh_array[i].data.nbPoint << "\n";
        binFile.write((char*)&mesh_array[i].data.nbPolygon, sizeof(unsigned int));
                                                                                oTestFile << mesh_array[i].data.nbPolygon << "\n";
        for (int j=0; j<mesh_array[i].data.nbPoint; j++)
        {
            for (int ii=0; ii < 3; ii++)
            {
                binFile.write((char*)&mesh_array[i].data.pntbl[j][ii], sizeof(int));
                                                                                oTestFile << mesh_array[i].data.pntbl[j][ii] << "\n";
            }
        }
        for (int j=0; j<mesh_array[i].data.nbPolygon; j++)
        {
            for (int ii=0; ii<3; ii++)
            {
                binFile.write((char*)&mesh_array[i].data.pltbl[j].norm[ii], sizeof(int));
                                                                                oTestFile << mesh_array[i].data.pltbl[j].norm[ii] << "\n";
            }
            for (int ii=0; ii<4; ii++)
            {
                binFile.write((char*)&mesh_array[i].data.pltbl[j].Vertices[ii], sizeof(unsigned short));
                                                                                oTestFile << mesh_array[i].data.pltbl[j].Vertices[ii] << "\n";
            }
        }
        for (int j=0; j<mesh_array[i].data.nbPolygon;j++)
        {
            if (mesh_array[i].data.attbl[j].texno < 0) mesh_array[i].data.attbl[j].texno = 0;
            binFile.write((char*)&mesh_array[i].data.attbl[j].texno, sizeof(unsigned short));
                                                                                oTestFile << mesh_array[i].data.attbl[j].texno << "\n";
        }
    }

    //binFile << "/END";  //Message to indicate EOF, disabled for now
    binFile.close();
    oTestFile.close();



    /*
    while (!inBinFile.eof())
    {
        inBinFile.read((char*)&test, sizeof(int));
       // cout << "\nTEST : " << test;
    }*/

   // cout << "\n" << binsize;

    //inBinFile.read((char*)&test, sizeof(int));
    //cout << "\nTEST 2 : " << test << "\n";

//    inBinFile.close();


readBin(filename);

}



/*********
To confirm the binary file works.
TODO : Allow conversion from Z-TREME binary files to normal Jo Engine header files
*********/
void readBin(string filename)
{
    string name;
    name =  filename + ".ZTM"; //Z-Treme Map custom binary file format
    ifstream ibinfile(name.c_str(), ios::in | ios::binary); //| ios::ate);

    /*** Result of the reading ***/
    name = filename + "_RESULT.txt";
    ofstream oTestFile(name.c_str(), ios::out);


    unsigned short mesh_tot = 0;
    unsigned int nbpoint = 0;
    unsigned int nbpolygon = 0;
   // unsigned int MeshSize = 0;
    unsigned int read_int;
    //ifstream inBinFile(filename.c_str(), ios::in | ios::binary);
    if (!ibinfile.is_open()) return;
    oTestFile << "Filename : " << filename.c_str() << "\n";

    ibinfile.read((char*)&mesh_tot, sizeof(unsigned short));
    oTestFile << "TOTAL MESHES : " << mesh_tot << "\n";

    for (int i=0; i<mesh_tot; i++)
    {
        if (ibinfile.eof()) break;
        oTestFile << "MESH No." << i << "\n";
        //ibinfile.read((char*)&MeshSize, sizeof(unsigned int));
        //oTestFile << "Size of mesh No." << i << " : " << MeshSize << "\n";
        ibinfile.read((char*)&nbpoint, sizeof(unsigned int));
        oTestFile << nbpoint << "\n";
        ibinfile.read((char*)&nbpolygon, sizeof(unsigned int));
        oTestFile << nbpolygon << "\n";

        for (int ii=0; ii<nbpoint; ii++)
        {
            int curpoint = 0;

            oTestFile << "POINT No." << ii << "(";
            for (int iii=0; iii<3; iii++)
            {
                ibinfile.read((char*)&curpoint, sizeof(int));
                if (iii!=2) oTestFile << curpoint << ", ";
                else oTestFile << curpoint;
            }
            oTestFile << ");\n";
        }
        for (int ii=0; ii<nbpolygon; ii++)
        {
            int curNorm = 0;
            unsigned short curVert = 0;

            oTestFile << "Polygon : " << ii << " Normals(";
            for (int iii=0; iii<3; iii++)
            {
                ibinfile.read((char*)&curNorm, sizeof(int));
                if (iii!=2) oTestFile << curNorm << ", ";
                else oTestFile << curNorm;
            }
            oTestFile << "), Vertices(";
            for (int iii=0; iii<4; iii++)
            {
                ibinfile.read((char*)&curVert, sizeof(unsigned short));
                if (iii!=3) oTestFile << curVert << ", ";
                else oTestFile << curVert;
            }
            oTestFile << ");\n";
        }
        for (int ii=0; ii<nbpolygon; ii++)
        {
            unsigned short curAttr = 0;
            oTestFile << "ATTRIBUTE(TEXNO : ";
            ibinfile.read((char*)&curAttr, sizeof(unsigned short));
            oTestFile << curAttr << ");\n";
        }
        oTestFile << "END OF MESH NO." << i << "\n";
    }

        ibinfile.close();
        oTestFile.close();
}


#endif
