#ifndef __OBJ2SGL_H
#define __OBJ2SGL_H

#include <string>
#include <sstream>
#include <iostream>
#include <fstream>
#include <stdio.h>

#include "Def.h"
//#include "obj_loader.h"

using namespace std;


int total_loaded_meshes = 0;
//int pointer = 0;


typedef struct
{
    POINT	pntbl[5000];
    Uint32	 nbPoint;
    POLYGON	pltbl[5000];
    Uint32	 nbPolygon;
    ATTR	attbl[5000];
} temp_data;

typedef struct
{
    temp_data data;
} _temp_mesh;

typedef struct
{
    int vertnorm[3];
} _temp_normals;


_temp_mesh ObjMesh[500]={0};
_temp_normals vertNorm[5000]; //High number, won't happen. Since the Obj file seperates normals from faces, we will store them in an array
int MeshPtr;
int TexturePtr=0;
string TextureArray[300]={""};

int generate_texture_list(string inString)
{
    if (inString=="None") return -1;
    for (int i=0; i<TexturePtr; i++)
    {
        if (inString == TextureArray[i])
        {
            cout << "Duplicated texture. Merging\n";
            return i;
        }
    }
    TextureArray[TexturePtr] = inString;
    TexturePtr++;
    return TexturePtr-1;
}

/**********************
At the moment the program doesn't read textures/pictures, so it can't write it directly in the file.
Instead we write a list (with id) of all the textures so that you can create your own list in the proper order.
**********************/
void write_texture_list(string filename)
{
    ofstream file("OUT/TEXTURELIST.txt", ios::out);
    if (!file.is_open()) return;
    file << "/*Texture list, you will have to manually add textures in this order as this program can't read them yet*/\n\n";
    for (int i=0; i<TexturePtr; i++)
    {
        file << i << " " << TextureArray[i] << "\n";
    }
    file.close();
}

void sort_faces(string inString, int MeshPtr, int index)
{

            string f1, f2, f3;

            char bufferChar[128]={}; //Don't ask, I'm more used to C than C++, so just went "fuck it"....
            int i = 0;
            for (i=0; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar[i]=inString[i];
            }
            f1 = bufferChar;
            int charPtr=0;            char bufferChar2[128]={};            f2 = "";
            for (i; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar2[charPtr]= inString[i];
                charPtr++;
            }
            f2 = bufferChar2;
            charPtr=0; char bufferChar3[128]={}; f3 = "";
            for (i; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar3[charPtr]=inString[i];
                charPtr++;
            }
            f3=bufferChar3;

  //cout << "F1 " << f1 << " F2 " << f2 << " F3 " << f3 << "\n";
  int i1, i2, i3;
  if (f1 != "")   i1 = std::stoi(f1) - 1;
  else (i1 = 0);
  if (f2 != "") i2 = std::stoi(f2) - 1;
  else (i2 = 0);
  if (f3 != "") i3 = std::stoi(f3) - 1;
  else (i3 = 0);

  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].Vertices[index] = i1;
  //ObjMesh[MeshPtr].data.attbl[ObjMesh[MeshPtr].data.nbPolygon].texno = i2;  AFAIK i2 is useless since the Saturn doesn't support texture coord
  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[0] = vertNorm[i3].vertnorm[0];
  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[1] = vertNorm[i3].vertnorm[1];
  ObjMesh[MeshPtr].data.pltbl[ObjMesh[MeshPtr].data.nbPolygon].norm[2] = vertNorm[i3].vertnorm[2];




}

void load_OBJ_to_mesh(ifstream *file, float scalefactor)
{
    string line;
    int pointer = 0;
    int textpointer = 0;
    int bufTotalNorm = 0;
    MeshPtr = -1;
   /* for (int i=0; i<500; i++)
    {
            ObjMesh[i].data.nbPoint = 0; ObjMesh[i].data.nbPolygon=0;
            for (int )
    }*/


    file->seekg(pointer, ios::beg);
    while(!file->eof())
    {
        getline(*file, line);
        if ((line[0] == 'o' && line[1] == ' ') || (line[0]== 'g'))
        {
            MeshPtr++;
            stringstream NameSS(line);
            string uselessbuffer;
            getline(NameSS, uselessbuffer, ' ');
            //NameSS >> ObjMesh->mesh_name;
            cout << "MESH " << MeshPtr << "\n";
            ObjMesh[MeshPtr].data.nbPoint = 0;
            ObjMesh[MeshPtr].data.nbPolygon = 0;
            //ObjMesh->filePtr = i;

            /*** Not sure yet if I need to reset the total norm***/
        }
        else if (line[0] == 'v' && line[1] == ' ')
        {

            stringstream PointSS(line);
            string uselessbuffer;
            getline(PointSS, uselessbuffer, ' ');
            string sx = ""; string sy = ""; string sz = "";
            PointSS >> sx >> sy >> sz;
            //cout << sx << " " << sy << " " << sz << "\n";

            float fx = std::stof(sx);            float fy = std::stof(sy);            float fz = std::stof(sz);
            int ix, iy, iz;
            ix = fx*65536.0*scalefactor; iy = fy*65536.0*scalefactor; iz=fz*65536.0*scalefactor;

            ObjMesh[MeshPtr].data.pntbl[ObjMesh[MeshPtr].data.nbPoint][0] = ix;
            ObjMesh[MeshPtr].data.pntbl[ObjMesh[MeshPtr].data.nbPoint][1] = iy;
            ObjMesh[MeshPtr].data.pntbl[ObjMesh[MeshPtr].data.nbPoint][2] = iz;
            ObjMesh[MeshPtr].data.nbPoint ++;
        }
        else if (line[0]== 'v' && line[1]== 'n')
        {
            stringstream NormSS(line);
            string bufferStr;
            getline(NormSS, bufferStr, ' ');
            string sx, sy, sz;
            NormSS >> sx >> sy >> sz;
            float fx = std::stof(sx);            float fy = std::stof(sy);            float fz = std::stof(sz);
            int ix, iy, iz;
            ix = fx*65536.0; iy = fy*65536.0; iz=fz*65536.0;

            vertNorm[bufTotalNorm].vertnorm[0] = ix;
            vertNorm[bufTotalNorm].vertnorm[1] = iy;
            vertNorm[bufTotalNorm].vertnorm[2] = iz;
            bufTotalNorm++;
        }
        else if (line[0]== 'm') //material library, not implemented for now
        {

        }
        else if (line[0]== 's')  //Shader? Not implemented
        {

        }
        else if (line[0]=='u' && line[1]=='s' && line[2]=='e' && line[3]=='m' && line[4]=='t' && line[5]=='l') //Yeah, I know we all got it after the 2 letters, but just in case some weird Obj format popup...
        {
            stringstream MtlSS(line);         string bufferStr;
            getline(MtlSS, bufferStr, ' ');
            string mtlName = {""};
            MtlSS >> mtlName;
            textpointer=generate_texture_list(mtlName);

            cout << "Detected texture/material named " << mtlName << "\n";

        }

        /*******   VERY UGLY, I know! ****************/
        else if (line[0] == 'f' && line[1] == ' ')
        {
            stringstream FaceSS(line);
            string bufferStr;
            getline(FaceSS, bufferStr, ' ');
            string p[4];
            FaceSS >> p[0] >> p[1] >> p[2] >> p[3];
            //stringstream tempP1(p1); stringstream tempP2(p2); stringstream tempP3(p3); stringstream tempP4(p4);
            sort_faces(p[0], MeshPtr, 0); sort_faces(p[1], MeshPtr, 1); sort_faces(p[2], MeshPtr, 2); sort_faces(p[3], MeshPtr, 3);

            ObjMesh[MeshPtr].data.attbl[ObjMesh[MeshPtr].data.nbPolygon].texno = textpointer; //Seems like 0 = No_Texture in SGL
            ObjMesh[MeshPtr].data.nbPolygon++;
        }
        pointer++;
    }
    file->clear();
    return;
}











int Obj2SGL(string filename, float scalefactor)  //Return the total amound of meshes if it doesn't fail
{
    ifstream file(filename, ios::in | ios::ate);
    if (!file.is_open()) return -1;
    load_OBJ_to_mesh(&file, scalefactor);

    file.close();

    for (int i=0; i< MeshPtr; i++)
    {
        mesh_array[i].data.nbPoint=ObjMesh[i].data.nbPoint;
        mesh_array[i].data.nbPolygon=ObjMesh[i].data.nbPolygon;

        for (int ii=0; ii<ObjMesh[i].data.nbPoint; ii++)
        {
            mesh_array[i].data.pntbl= ObjMesh[i].data.pntbl;
        }
        for (int ii=0; ii<ObjMesh[i].data.nbPolygon; ii++)
        {
            mesh_array[i].data.pltbl=ObjMesh[i].data.pltbl;
            mesh_array[i].data.attbl=ObjMesh[i].data.attbl;
        }

    cout << "Mesh ID : " << i << "  nbPoint : " <<    mesh_array[i].data.nbPoint << " nbPolygon : " << mesh_array[i].data.nbPolygon << "\n";
    }

    /******* The program doesn't read the textures yet, so instead we just write the list of textures used so that
    you can manualy add it in the proper order **********/
    write_texture_list(filename);


    return MeshPtr;
}








#endif
